"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = SixueTree;

var _dropdown = _interopRequireDefault(require("@alifd/next/lib/dropdown"));

var _menu = _interopRequireDefault(require("@alifd/next/lib/menu"));

var _button = _interopRequireDefault(require("@alifd/next/lib/button"));

var _icon = _interopRequireDefault(require("@alifd/next/lib/icon"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _balloon = _interopRequireDefault(require("@alifd/next/lib/balloon"));

var _tree = _interopRequireDefault(require("@alifd/next/lib/tree"));

var _react = _interopRequireWildcard(require("react"));

require("./index.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TreeNode = _tree["default"].Node;
var Tooltip = _balloon["default"].Tooltip;

function SixueTree(props) {
  var others = (0, _extends2["default"])({}, props);

  var _useState = (0, _react.useState)([]),
      now = _useState[0],
      setNow = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      treeSelected = _useState2[0],
      setTreeSelected = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      expandedKeys = _useState3[0],
      setExpandedKeys = _useState3[1];

  var _useState4 = (0, _react.useState)(true),
      auto = _useState4[0],
      setAuto = _useState4[1];

  (0, _react.useEffect)(function () {
    var tree = document.getElementById('sixueTree');
    tree.addEventListener('scroll', scrollMeun);
    return function () {
      tree.addEventListener('scroll', scrollMeun);
    };
  }, []);
  (0, _react.useEffect)(function () {
    setTreeSelected(others.selected);
    setExpandedKeys(others.expand);
    setAuto(true);
  }, [others.expand, others.selected]);

  var scrollMeun = function scrollMeun() {
    if (document.getElementById('treeFunc')) {
      // @ts-ignore
      document.getElementsByClassName('next-overlay-wrapper')[0].style = 'display: none';
    }
  };

  var getItemByPos = function getItemByPos(pos) {
    return pos.split('-').slice(1).reduce(function (ret, num) {
      return ret.children[num];
    }, {
      children: others.dataSource
    });
  };

  var loop = function loop(data, num) {
    var dataLength = data.length;
    return data.map(function (item, index) {
      if (item.enabled) {
        return loopAndLabelText(item, index, dataLength, num);
      } else {
        if (others.disableShow) {
          return loopAndLabelText(item, index, dataLength, num);
        }

        return '';
      }
    });
  };

  var loopAndLabelText = function loopAndLabelText(item, index, dataLength, num) {
    if (item.children) {
      return /*#__PURE__*/_react["default"].createElement(TreeNode, {
        key: item.key,
        label: labelText(item, index, dataLength, num)
      }, loop(item.children, num + 1));
    }

    return /*#__PURE__*/_react["default"].createElement(TreeNode, {
      key: item.key,
      label: labelText(item, index, dataLength, num),
      disabled: !!item.disabled
    });
  }; // eslint-disable-next-line max-len


  var labelText = function labelText(data, index, dataLength, num) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "treeName",
      key: data.key
    }, data.group && /*#__PURE__*/_react["default"].createElement(_icon["default"], {
      className: "treeFile",
      type: others.groupingIcon
    }), /*#__PURE__*/_react["default"].createElement("p", null, data.label.length > 8 ? /*#__PURE__*/_react["default"].createElement(Tooltip, {
      align: "t",
      trigger: /*#__PURE__*/_react["default"].createElement(_button["default"], {
        className: "treeName1",
        text: true,
        onClick: function onClick() {
          infoFunc(data.key);
        }
      }, data.label)
    }, data.label) : /*#__PURE__*/_react["default"].createElement(_button["default"], {
      className: "treeName1",
      text: true,
      onClick: function onClick() {
        infoFunc(data.key);
      }
    }, data.label), !data.enabled && /*#__PURE__*/_react["default"].createElement("i", {
      className: "stop"
    }, "[\u5DF2\u505C\u7528]"), others.rename || others.addChild || others.move || others.remove || others.enableDisable ? /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
      trigger: /*#__PURE__*/_react["default"].createElement(_button["default"], {
        text: true,
        className: "treeMore"
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "ellipsis"
      })),
      triggerType: "click"
    }, /*#__PURE__*/_react["default"].createElement(_menu["default"], {
      className: "treeFunc",
      id: "treeFunc"
    }, others.rename && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.rename();
      }
    }, "\u91CD\u547D\u540D"), data.group && num < others.groupingMaxNum - 1 && others.addChild && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        var pos = now.props.pos;
        var item = getItemByPos(pos);

        if (!(item !== null && item !== void 0 && item.children)) {
          item.children = [];
        }

        others.addChild();
      }
    }, "\u6DFB\u52A0\u5B50\u5206\u7EC4"), index !== 0 && others.move && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('up');
      }
    }, "\u4E0A\u79FB"), index !== dataLength - 1 && others.move && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('down');
      }
    }, "\u4E0B\u79FB"), index !== 0 && others.move && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('top');
      }
    }, "\u7F6E\u9876"), index !== dataLength - 1 && others.move && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.move('bottom');
      }
    }, "\u7F6E\u5E95"), data.group && others.remove && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        others.remove('delete');
      }
    }, "\u5220\u9664"), !data.group && others.enableDisable && /*#__PURE__*/_react["default"].createElement(_menu["default"].Item, {
      onClick: function onClick() {
        var pos = now.props.pos;
        var item = getItemByPos(pos);
        others.enableDisable(item.enabled);
      }
    }, data.enabled ? '停用' : '启用'))) : ''));
  };

  var infoFunc = function infoFunc(keys) {
    var arr = [];
    arr.push(keys);
    setTreeSelected([].concat(arr));

    if (keys && expandedKeys.indexOf(keys) === -1) {
      expandedKeys.push(keys);
      setExpandedKeys([].concat(expandedKeys));
      setAuto(true);
    } else {
      expandedKeys.splice(expandedKeys.indexOf(keys), 1);
      setExpandedKeys([].concat(expandedKeys));
      setAuto(false);
    }
  };

  var onSelect = function onSelect(keys, info) {
    var pos = info.node.props.pos;
    var item = getItemByPos(pos);
    others.onChange(item);
    setNow(info.node);
  };

  var onExpand = function onExpand(keys) {
    setExpandedKeys(keys);
    setAuto(false);
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    id: "sixueTree",
    className: "sixueTree"
  }, /*#__PURE__*/_react["default"].createElement(_tree["default"], {
    isNodeBlock: true,
    autoExpandParent: auto,
    selectedKeys: treeSelected,
    expandedKeys: expandedKeys,
    onExpand: onExpand,
    onSelect: onSelect,
    defaultExpandAll: false,
    selectable: true
  }, loop(others.dataSource, 0)));
}

SixueTree.defaultProps = {
  groupingIcon: 'wenjianjia',
  disableShow: true,
  groupingMaxNum: 10
};